%global gem_name    flexmock
Summary:             Mock object library for ruby
Name:                rubygem-%{gem_name}
Version:             2.3.6
Release:             2
License:             MIT
URL:                 https://github.com/doudou/flexmock
Source0:             https://rubygems.org/gems/%{gem_name}-%{version}.gem
Source1:             https://github.com/doudou/%{gem_name}/archive/v%{version}.tar.gz
Patch1:              rubygem-flexmock-2.3.6-testsuite-binding-source.patch
Patch2:              rubygem-flexmock-2.3.6-accept-keywords.patch
Patch3:              rubygem-flexmock-2.3.6-workaround-relax-error-message.patch
Requires:            ruby(release)
BuildRequires:       ruby(release) rubygems-devel rubygem(minitest) >= 5 rubygem(rspec) >= 3
Requires:            ruby(rubygems)
Provides:            rubygem(%{gem_name}) = %{version}-%{release}
BuildArch:           noarch
%description
FlexMock is a simple, but flexible, mock object library for Ruby unit
testing.

%package help
Summary:             Documentation for %{name}
Requires:            %{name} = %{version}-%{release}
Provides:            %{name}-doc = %{version}-%{release}
Obsoletes:           %{name}-doc < %{version}-%{release}
%description help
This package contains documentation for %{name}.

%prep
gem unpack %{SOURCE0}
%setup -q -D -T -n  %{gem_name}-%{version} -a 1

gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec

(
cd %{gem_name}-%{version}
%patch1 -p1
%patch3 -p1
)
%patch2 -p1

find . -name \*.rb | xargs sed -i -e '\@/usr/bin/env@d'
find . -name \*.gem -or -name \*.rb -or -name \*.rdoc | xargs chmod 0644

%build
gem build %{gem_name}.gemspec
%gem_install

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* %{buildroot}%{gem_dir}/
pushd %{buildroot}%{gem_instdir}
rm -rf \
    .autotest .gitignore .togglerc .travis.yml .yardopts \
    Gemfile \
    Rakefile \
    flexmock.blurb \
    flexmock.gemspec \
    install.rb
popd

%check
cp -a %{gem_name}-%{version}/test .%{gem_instdir}
pushd .%{gem_instdir}
pwd
ls
export RUBYOPT=-W:deprecated
export RUBYLIB=$(pwd)/lib:$(pwd):$(pwd)/test
ruby \
    -e 'Dir.glob("test/*_test.rb").each {|f| require f}'
rspec test/rspec_integration/
popd

%files
%dir    %{gem_instdir}
%doc    %{gem_instdir}/[A-Z]*
%{gem_libdir}
%{gem_instdir}/rakelib/
%exclude    %{gem_cache}
%{gem_spec}

%files help
%{gem_instdir}/todo.txt
%{gem_instdir}/doc/
%{gem_docdir}/

%changelog
* Tue Feb 22 2022 chenchen <chen_aka_jan@163.com> - 2.3.6-2
- fix build error by upgrading to ruby3

* Mon Aug 24 2020 xiezheng <xiezheng4@huawei.com> - 2.3.6-1
- package init
